<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/sweep_disk_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span>:Info: sweep_disk_:  1982-12-28  sweep_disk_
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>
<span id="L4" class="LineNr">  4 </span>Entry points in sweep_disk_:
<span id="L5" class="LineNr">  5 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L6" class="LineNr">  6 </span>
<span id="L7" class="LineNr">  7 </span>
<span id="L8" class="LineNr">  8 </span>:Entry: sweep_disk_: 1982-11-04  sweep_disk_
<span id="L9" class="LineNr">  9 </span>
<span id="L10" class="LineNr"> 10 </span>
<span id="L11" class="LineNr"> 11 </span>Function:
<span id="L12" class="LineNr"> 12 </span>The sweep_disk_ subroutine walks through the subtree below a specified
<span id="L13" class="LineNr"> 13 </span>node of the directory hierarchy, calling a user-supplied subroutine
<span id="L14" class="LineNr"> 14 </span>once for every entry in every directory in the subtree.
<span id="L15" class="LineNr"> 15 </span>
<span id="L16" class="LineNr"> 16 </span>
<span id="L17" class="LineNr"> 17 </span>Syntax:
<span id="L18" class="LineNr"> 18 </span>declare sweep_disk_ entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>168<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> entry<span class="textRainbow_lv0_p0">)</span>;
<span id="L19" class="LineNr"> 19 </span>call sweep_disk_ <span class="textRainbow_lv0_p0">(</span>base_path<span class="textRainbow_lv0_o0">,</span> subroutine<span class="textRainbow_lv0_p0">)</span>;
<span id="L20" class="LineNr"> 20 </span>
<span id="L21" class="LineNr"> 21 </span>
<span id="L22" class="LineNr"> 22 </span>Arguments:
<span id="L23" class="LineNr"> 23 </span>base_path
<span id="L24" class="LineNr"> 24 </span>   is the pathname of the directory that is the base node of the
<span id="L25" class="LineNr"> 25 </span>   subtree to be scanned.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L26" class="LineNr"> 26 </span>subroutine
<span id="L27" class="LineNr"> 27 </span>   is an entry point called for each branch or link in the subtree <span class="textRainbow_lv0_p0">(</span>see
<span id="L28" class="LineNr"> 28 </span>   &quot;User-Supplied Subroutine&quot; below<span class="textRainbow_lv0_p0">)</span>.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L29" class="LineNr"> 29 </span>
<span id="L30" class="LineNr"> 30 </span>
<span id="L31" class="LineNr"> 31 </span>User-Supplied Subroutine:
<span id="L32" class="LineNr"> 32 </span>The subroutine provided to sweep_disk_ should have the following
<span id="L33" class="LineNr"> 33 </span>declaration and call sequence:
<span id="L34" class="LineNr"> 34 </span>
<span id="L35" class="LineNr"> 35 </span>   declare subroutine entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>168<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>32<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span>
<span id="L36" class="LineNr"> 36 </span>      fixed bin<span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>32<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L37" class="LineNr"> 37 </span>   call subroutine <span class="textRainbow_lv0_p0">(</span>path<span class="textRainbow_lv0_o0">,</span> dir_name<span class="textRainbow_lv0_o0">,</span> level<span class="textRainbow_lv0_o0">,</span> entryname<span class="textRainbow_lv0_o0">,</span> b_ptr<span class="textRainbow_lv0_o0">,</span> n_ptr<span class="textRainbow_lv0_p0">)</span>;
<span id="L38" class="LineNr"> 38 </span>
<span id="L39" class="LineNr"> 39 </span>
<span id="L40" class="LineNr"> 40 </span>User-Supplied Subroutine Arguments:
<span id="L41" class="LineNr"> 41 </span>path
<span id="L42" class="LineNr"> 42 </span>   is the pathname of the directory immediately superior to the
<span id="L43" class="LineNr"> 43 </span>   directory that contains the current entry.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L44" class="LineNr"> 44 </span>dir_name
<span id="L45" class="LineNr"> 45 </span>   is the name of the directory that contains the current entry.
<span id="L46" class="LineNr"> 46 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L47" class="LineNr"> 47 </span>level
<span id="L48" class="LineNr"> 48 </span>   is the number of levels deep from the base_path directory of the
<span id="L49" class="LineNr"> 49 </span>   subtree.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L50" class="LineNr"> 50 </span>
<span id="L51" class="LineNr"> 51 </span>
<span id="L52" class="LineNr"> 52 </span>entryname
<span id="L53" class="LineNr"> 53 </span>   is the primary name on the current entry.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L54" class="LineNr"> 54 </span>b_ptr
<span id="L55" class="LineNr"> 55 </span>   is a pointer to the branch structure returned by hcs_$star_list for
<span id="L56" class="LineNr"> 56 </span>   the current entry.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L57" class="LineNr"> 57 </span>n_ptr
<span id="L58" class="LineNr"> 58 </span>   is a pointer to the names area for the immediately superior
<span id="L59" class="LineNr"> 59 </span>   directory of the current entry returned by hcs_$star_list.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L60" class="LineNr"> 60 </span>
<span id="L61" class="LineNr"> 61 </span>
<span id="L62" class="LineNr"> 62 </span>:Entry:  dir_list:  1982-11-04  sweep_disk_$dir_list
<span id="L63" class="LineNr"> 63 </span>
<span id="L64" class="LineNr"> 64 </span>
<span id="L65" class="LineNr"> 65 </span>Function:  This entry point operates in the same way as sweep_disk_ but
<span id="L66" class="LineNr"> 66 </span>is much less expensive to use and does not return
<span id="L67" class="LineNr"> 67 </span>date_time_contents_modified, date_time_used, or bit_count.
<span id="L68" class="LineNr"> 68 </span>
<span id="L69" class="LineNr"> 69 </span>
<span id="L70" class="LineNr"> 70 </span>Syntax:
<span id="L71" class="LineNr"> 71 </span>declare sweep_disk_$dir_list entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>168<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> entry<span class="textRainbow_lv0_p0">)</span>;
<span id="L72" class="LineNr"> 72 </span>call sweep_disk_$dir_list <span class="textRainbow_lv0_p0">(</span>base_path<span class="textRainbow_lv0_o0">,</span> subroutine<span class="textRainbow_lv0_p0">)</span>;
<span id="L73" class="LineNr"> 73 </span>
<span id="L74" class="LineNr"> 74 </span>
<span id="L75" class="LineNr"> 75 </span>Arguments:
<span id="L76" class="LineNr"> 76 </span>base_path
<span id="L77" class="LineNr"> 77 </span>   is the pathname of the directory that is the base node of the
<span id="L78" class="LineNr"> 78 </span>   subtree to be scanned.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L79" class="LineNr"> 79 </span>subroutine
<span id="L80" class="LineNr"> 80 </span>   is an entry point called for each branch or link in the subtree <span class="textRainbow_lv0_p0">(</span>see
<span id="L81" class="LineNr"> 81 </span>   &quot;Notes&quot; below<span class="textRainbow_lv0_p0">)</span>.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L82" class="LineNr"> 82 </span>
<span id="L83" class="LineNr"> 83 </span>
<span id="L84" class="LineNr"> 84 </span>Notes: The user-supplied subroutine is called in the same way as
<span id="L85" class="LineNr"> 85 </span>for sweep_disk_, but b_ptr points instead to the branch structure
<span id="L86" class="LineNr"> 86 </span>returned by hcs_$star_dir_list.  See the hcs_$star_ subroutine.
<span id="L87" class="LineNr"> 87 </span>See &quot;User-Supplied Subroutine&quot; in the sweep_disk_ entrypoint for
<span id="L88" class="LineNr"> 88 </span>syntax of this subroutine.
<span id="L89" class="LineNr"> 89 </span>
<span id="L90" class="LineNr"> 90 </span>If the base_path argument to the sweep_disk_ subroutine is the
<span id="L91" class="LineNr"> 91 </span>root <span class="textRainbow_lv0_p0">(</span>&quot;&gt;&quot;<span class="textRainbow_lv0_p0">)</span>, the directory &gt;process_dir_dir is omitted from the tree
<span id="L92" class="LineNr"> 92 </span>walk.
<span id="L93" class="LineNr"> 93 </span>
<span id="L94" class="LineNr"> 94 </span>
<span id="L95" class="LineNr"> 95 </span>The sweep_disk_ subroutine attempts to force access to the directories
<span id="L96" class="LineNr"> 96 </span>in the subtree by adding an ACL term of the form &quot;sma
<span id="L97" class="LineNr"> 97 </span>Person.Project.tag&quot; to each directory ACL, and deleting that ACL term
<span id="L98" class="LineNr"> 98 </span>when finished processing the directory.  If the user does not have
<span id="L99" class="LineNr"> 99 </span>sufficient access to add this ACL term for a given directory, the
<span id="L100" class="LineNr">100 </span>subroutine processes those parts of the subtree under it where the user
<span id="L101" class="LineNr">101 </span>already has sufficient access to list the directories.
<span id="L102" class="LineNr">102 </span>
<span id="L103" class="LineNr">103 </span>
<span id="L104" class="LineNr">104 </span>:Entry:  loud:  1982-11-04  sweep_disk_$loud
<span id="L105" class="LineNr">105 </span>
<span id="L106" class="LineNr">106 </span>
<span id="L107" class="LineNr">107 </span>Function:  This entry point is used for debugging subsystems that use
<span id="L108" class="LineNr">108 </span>the sweep_disk_ subroutine.  It sets an internal static flag in
<span id="L109" class="LineNr">109 </span>sweep_disk_ that causes sweep_disk_ to call com_err_ and report any
<span id="L110" class="LineNr">110 </span>errors encountered in listing directories or setting ACLs.  Since
<span id="L111" class="LineNr">111 </span>sweep_disk_$loud takes no arguments, and should only be used for
<span id="L112" class="LineNr">112 </span>debugging, it can readily be invoked as a command <span class="textRainbow_lv0_p0">(</span>&quot;sweep_disk_$loud&quot;<span class="textRainbow_lv0_p0">)</span>
<span id="L113" class="LineNr">113 </span>to cause sweep_disk_ to exhibit this debugging behavior for the rest of
<span id="L114" class="LineNr">114 </span>the process.  There is no corresponding entry point to turn the switch
<span id="L115" class="LineNr">115 </span>off.  Because this is a static switch, and affects all callers of
<span id="L116" class="LineNr">116 </span>sweep_disk_, it should not be turned on, except to debug, when it is
<span id="L117" class="LineNr">117 </span>important to understand the exact nature of any errors encountered.
<span id="L118" class="LineNr">118 </span>Normally, sweep_disk_ ignores errors and continues as best it can.
<span id="L119" class="LineNr">119 </span>
<span id="L120" class="LineNr">120 </span>
<span id="L121" class="LineNr">121 </span>Syntax:
<span id="L122" class="LineNr">122 </span>declare sweep_disk_$loud entry <span class="textRainbow_lv0_p0">()</span>;
<span id="L123" class="LineNr">123 </span>call sweep_disk_$loud <span class="textRainbow_lv0_p0">()</span>;
<span id="L124" class="LineNr">124 </span>
<span id="L125" class="LineNr">125 </span>
<span id="L126" class="LineNr">126 </span>:hcom:
<span id="L127" class="LineNr">127 </span>
<span id="L128" class="LineNr">128 </span>
<span id="L129" class="LineNr">129 </span>
<span id="L130" class="LineNr">130 </span>/****^  HISTORY COMMENTS:
<span id="L131" class="LineNr">131 </span>  1) change<span class="textRainbow_lv0_p0">(</span>2020-05-19<span class="textRainbow_lv0_o0">,</span>GDixon<span class="textRainbow_lv0_p0">)</span>, approve<span class="textRainbow_lv0_p0">(</span>2021-02-22<span class="textRainbow_lv0_o0">,</span>MCR10088<span class="textRainbow_lv0_p0">)</span>,
<span id="L132" class="LineNr">132 </span>     audit<span class="textRainbow_lv0_p0">(</span>2021-05-27<span class="textRainbow_lv0_o0">,</span>Swenson<span class="textRainbow_lv0_p0">)</span>, install<span class="textRainbow_lv0_p0">(</span>2021-05-27<span class="textRainbow_lv0_o0">,</span>MR12.6g-0056<span class="textRainbow_lv0_p0">)</span>:
<span id="L133" class="LineNr">133 </span>     Fix info seg format errors reported by verify_info.
<span id="L134" class="LineNr">134 </span>                                                   END HISTORY COMMENTS */
<span id="L135" class="LineNr">135 </span>
<span id="L136" class="LineNr">136 </span>
<span id="L137" class="LineNr">137 </span>
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
